//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <list>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

class IntSequence {
  private:
    int value;
  public:
    // 
    IntSequence (int initialValue)
     : value(initialValue) {
    }

    // " "
    int operator() () {
        return value++;
    }
};


int main(int argc, char* argv[])
{
  list<int> coll;
  IntSequence seq(1);    //   ,   1

  //    1  4
  // -     ,
  //          5
  generate_n<back_insert_iterator<list<int> >,
             int, IntSequence&>(back_inserter(coll),    // 
                                4,      //  
                                seq);   //  
  PRINT_ELEMENTS(coll," :\n");

  //    42  45
  generate_n (back_inserter(coll),      // 
              4,                        //  
              IntSequence(42));         //  
  PRINT_ELEMENTS(coll,"  :\n");

  //   
  // -     ,
  //           5
  generate_n (back_inserter(coll),      // 
              4,                        //  
              seq);                     //  
  PRINT_ELEMENTS(coll," (    ):\n");
    
  //    
  generate_n (back_inserter(coll),      // 
              4,                        //  
              seq);                     //  
  PRINT_ELEMENTS(coll,":\n");

  getch();
  return 0;
}

//---------------------------------------------------------------------------